/*!
 * axios-api-module.js v3.1.1
 * (c) 2020 Calvin Von
 * Released under the MIT License.
 */
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t(require("axios")):"function"==typeof define&&define.amd?define(["axios"],t):"object"==typeof exports?exports.ApiModule=t(require("axios")):e.ApiModule=t(e.axios)}("undefined"!=typeof self?self:this,(function(e){return r={},t.m=o=[function(e,t){e.exports=function(e){return e&&e.__esModule?e:{default:e}}},function(e,t){e.exports=function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}},function(e,t){function o(e,t){for(var o=0;o<t.length;o++){var r=t[o];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}e.exports=function(e,t,r){return t&&o(e.prototype,t),r&&o(e,r),e}},function(e,t){e.exports=function(e,t,o){return t in e?Object.defineProperty(e,t,{value:o,enumerable:!0,configurable:!0,writable:!0}):e[t]=o,e}},function(e,t,o){var r,n,a;n=[t,o(5)],void 0===(a="function"==typeof(r=function(r,n){"use strict";var a=o(0);Object.defineProperty(r,"__esModule",{value:!0}),r.default=void 0;var i=(n=a(n)).default;r.default=i,e.exports=t.default})?r.apply(t,n):r)||(e.exports=a)},function(e,t,o){var r,n,a;n=[t,o(1),o(2),o(3),o(6),o(7)],void 0===(a="function"==typeof(r=function(r,n,a,i,s,u){"use strict";var l=o(0);Object.defineProperty(r,"__esModule",{value:!0}),r.default=void 0,n=l(n),a=l(a),i=l(i),s=l(s),u=l(u);var c=function(e,t){return t(e.responseError)},f=function(){function e(){var t=this,o=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};(0,n.default)(this,e),(0,i.default)(this,"options",{}),(0,i.default)(this,"apiMapper",void 0),(0,i.default)(this,"foreRequestHook",void 0),(0,i.default)(this,"postRequestHook",void 0),(0,i.default)(this,"fallbackHook",void 0);var r=o.metadatas,a=void 0===r?{}:r,u=o.module,l=o.console,c=void 0===l||l,f=o.baseConfig,d=void 0===f?{}:f;this.options={axios:s.default.create(d),metadatas:a,module:u,console:c,baseConfig:d},this.apiMapper={},u?Object.keys(a).forEach((function(e){t.apiMapper[e]=t._proxyable(a[e],e)})):this.apiMapper=this._proxyable(a),Object.defineProperty(this.apiMapper,"$module",{configurable:!1,enumerable:!1,writable:!1,value:this})}return(0,a.default)(e,[{key:"useBefore",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:c;this.foreRequestHook=e}},{key:"useAfter",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:c;this.postRequestHook=e}},{key:"useCatch",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:c;this.fallbackHook=e}},{key:"generateCancellationSource",value:function(){return s.default.CancelToken.source()}},{key:"getAxios",value:function(){return this.options.axios}},{key:"getInstance",value:function(){return this.apiMapper}},{key:"foreRequestMiddleWare",value:function t(o,r){var n=this.foreRequestHook||e.foreRequestHook||c;if("function"==typeof n)try{n.call(this,o,r)}catch(t){console.error("[ApiModule] An error occurred in foreRequestMiddleWare: ",t),r()}else console.warn("[ApiModule] foreRequestMiddleWare: ".concat(n," is not a valid foreRequestHook function")),r()}},{key:"postRequestMiddleWare",value:function t(o,r){var n=this.postRequestHook||e.postRequestHook||c;if("function"==typeof n)try{n.call(this,o,r)}catch(t){console.error("[ApiModule] An error occurred in postRequestMiddleWare: ",t),r()}else console.warn("[ApiModule] postRequestMiddleWare: ".concat(n," is not a valid foreRequestHook function")),r()}},{key:"fallbackMiddleWare",value:function(t,o){var r=this,n=function(){if(r.options.console){var e=t.metadata,n=e.method,i=e.url,s="[ApiModule] [".concat(n.toUpperCase()," ").concat(i,"] failed with ").concat(a.message);console.error(new Error(s))}o()},a=t.responseError,i=this.fallbackHook||e.fallbackHook||n;if("function"==typeof i)try{i.call(this,t,o)}catch(a){console.error("[ApiModule] An error occurred in fallbackMiddleWare: ",a),o()}else console.warn("[ApiModule] fallbackMiddleWare: ".concat(i," is not a valid fallbackHook function")),n()}},{key:"_proxyable",value:function(e,t){var o={};for(var r in e)e.hasOwnProperty(r)&&(o[r]=this._proxyApiMetadata(e,r,t));return o}},{key:"_proxyApiMetadata",value:function(e,t,o){var r=this,n=e[t];if("[object Object]"!==Object.prototype.toString.call(n))throw new TypeError("[ApiModule] api metadata [".concat(t,"] is not an object"));var a=new u.default(n,this.options);if(a._metadataKeys=[o,t].filter(Boolean),!a.url||!a.method)throw console.warn("[ApiModule] check your api metadata for [".concat(t,"]: "),n),new Error("[ApiModule] api metadata [".concat(t,"]: 'method' or 'url' value not found"));var i=function(e){var t=e||a.responseError;return!!t&&(t instanceof Error?a.setError(t):"string"==typeof t?a.setError(new Error(t)):a.setError(t),!0)},s=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};return a.setError(null).setResponse(null).setAxiosOptions({}).setData(e)._setRequestOptions(t),new Promise((function(e,t){r.foreRequestMiddleWare(a,(function(o){if(i(o))r.fallbackMiddleWare(a,(function(){t(a.responseError)}));else{var n=a.data||{},s=n.query,u=void 0===s?{}:s,l=n.body,c=void 0===l?{}:l,f=Object.assign({},{method:a.method.toLowerCase(),url:a.url,params:u,data:c},a.axiosOptions);r.options.axios(f).then((function(t){a.setResponse(t),r.postRequestMiddleWare(a,(function(t){if(i(t))throw a.responseError;e(a.response)}))})).catch((function(e){i(e),r.fallbackMiddleWare(a,(function(e){i(e),t(a.responseError)}))}))}}))}))};return s.context=a,s}}],[{key:"globalBefore",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:c;e.foreRequestHook=t}},{key:"globalAfter",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:c;e.postRequestHook=t}},{key:"globalCatch",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:c;e.fallbackHook=t}}]),e}();r.default=f,(0,i.default)(f,"foreRequestHook",void 0),(0,i.default)(f,"postRequestHook",void 0),(0,i.default)(f,"fallbackHook",void 0),e.exports=t.default})?r.apply(t,n):r)||(e.exports=a)},function(t,o){t.exports=e},function(e,t,o){var r,n,a;n=[t,o(1),o(2),o(3)],void 0===(a="function"==typeof(r=function(r,n,a,i){"use strict";var s=o(0);function u(e,t){var o=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),o.push.apply(o,r)}return o}Object.defineProperty(r,"__esModule",{value:!0}),r.default=void 0,n=s(n),a=s(a),i=s(i);var l=function(){function e(t,o){(0,n.default)(this,e),(0,i.default)(this,"_options",void 0),(0,i.default)(this,"_metadata",void 0),(0,i.default)(this,"_metadataKeys",""),(0,i.default)(this,"_data",null),(0,i.default)(this,"_response",null),(0,i.default)(this,"_responseError",null),(0,i.default)(this,"_reqAxiosOpts",{}),(0,i.default)(this,"_metaAxiosOpts",{}),this._metadata=t,this._options=o}return(0,a.default)(e,[{key:"setData",value:function(e){return this._data=e,this}},{key:"setResponse",value:function(e){return this._response=e,this}},{key:"setError",value:function(e){return this._responseError=e,this}},{key:"_setRequestOptions",value:function(e){return c(e)?this._reqAxiosOpts=e:console.error("[ApiModule] the request parameter, the parameter `".concat(e,"` is not an object")),this}},{key:"setAxiosOptions",value:function(e){return c(e)?this._metaAxiosOpts=e:console.error("[ApiModule] configure axios options error, the parameter `".concat(e,"` is not an object")),this}},{key:"metadata",get:function(){return function(e){for(var t=1;t<arguments.length;t++){var o=null!=arguments[t]?arguments[t]:{};t%2?u(Object(o),!0).forEach((function(t){(0,i.default)(e,t,o[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(o)):u(Object(o)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(o,t))}))}return e}({},this._metadata)}},{key:"metadataKeys",get:function(){return this._metadataKeys}},{key:"method",get:function(){return this._metadata.method}},{key:"baseURL",get:function(){return this.axiosOptions.baseURL||""}},{key:"url",get:function(){var e=this._metadata.url,t=(this.data||{}).params;return c(t)?this.baseURL+e.replace(/\B(?::(\w+)|{(\w+)})/g,(function(){return t[(arguments.length<=1?void 0:arguments[1])||(arguments.length<=2?void 0:arguments[2])]})):this.baseURL+e}},{key:"data",get:function(){return this._data}},{key:"response",get:function(){return this._response}},{key:"responseError",get:function(){return this._responseError}},{key:"axiosOptions",get:function(){var e=this._reqAxiosOpts,t=this._metaAxiosOpts;return Object.assign({},t,e)}}]),e}();function c(e){return"[object Object]"===Object.prototype.toString.call(e)}r.default=l,e.exports=t.default})?r.apply(t,n):r)||(e.exports=a)}],t.c=r,t.d=function(e,o,r){t.o(e,o)||Object.defineProperty(e,o,{enumerable:!0,get:r})},t.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},t.t=function(e,o){if(1&o&&(e=t(e)),8&o)return e;if(4&o&&"object"==typeof e&&e&&e.__esModule)return e;var r=Object.create(null);if(t.r(r),Object.defineProperty(r,"default",{enumerable:!0,value:e}),2&o&&"string"!=typeof e)for(var n in e)t.d(r,n,function(t){return e[t]}.bind(null,n));return r},t.n=function(e){var o=e&&e.__esModule?function(){return e.default}:function(){return e};return t.d(o,"a",o),o},t.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},t.p="",t(t.s=4);function t(e){if(r[e])return r[e].exports;var n=r[e]={i:e,l:!1,exports:{}};return o[e].call(n.exports,n,n.exports,t),n.l=!0,n.exports}var o,r}));